#include <stdio.h>
#include "vogl.h"
#include "globals.h"
#include <math.h>
#include "standard.h"
#include "vogltools.h"

#include "vodevice.h"
#include "bsp.h"
#include "hungarian.h"
#include "render_kiosk.h"
#include "render_dir.h"
#include "render_search.h"
#include "render_telnet.h"
#include "render_document.h"
#include "../src/eyemotion.h"
#include <math.h>
#include "hungarian.h"




static void
Init_GL()
{
     winopen("Gopher VR...");
     ginit();
     vsetflush(0);
     hfont( "futura.l" );

     V_ShadingFreq( d_STATIC ); 

     backface(0); 
     doublebuffer();
     gconfig();
}

void
PreloadObjects()
{
     Kiosk_init();
     Search_init();    
     Telnet_init();  
     Dir_init();  
     Doc_init();  
     Sound_init();
}

#include "uofm.h"

void
InitialScene(void)
{
     long	theID;
     FILE       *foo;

     Init_GL();

     oursceneid = genscene();

     bgnscene(oursceneid);

/*     PlayAudio("/home/arcwelder/lindner/mods/beyond.mod");*/

     makegroundplane();

/* now its OK to make the objects and place them in the world */

     pushmatrix();
{
     int id = ParseArray(UofMnff, "world/nff-spd");
     if (id != -1) {
	  translate(0.0, -100.0, 0.0);
	  scale(2.0, 2.0, 2.0);
	  callobj(id);
	  rot(180.0, 'y');
	  translate(0.0, 0.0, -1.0);
	  callobj(id);
     }
}
     popmatrix();

     endscene(oursceneid);    
     EyeInitialPoint();

}



void
Bootstrap(char *host, int port)
{
     long	theID;
     sleep(1);
     PreloadObjects();

     /* now its OK to make the objects and place them in the world */

     WorldStart(host, port, "");
}


 

static float Eyeangle_ds = 0.0;
static float Eyeazimuth_ds = 0.0;
static float Eyey = 0.0, Eyex = 0.0, Eyez = 0.0;

static long currentscene = 0;

#include <sys/time.h>
static 
bgntime()
{
     static int oldtime;
     static int frames = 0;
     int timenow;

     timenow = time(NULL);
     frames ++;

     if (timenow != oldtime) {
	  printf("frame rate %f fps\n", (float)frames/(timenow - oldtime));
	  frames = 0;
     }
     oldtime = timenow;
}


void
drawscene(void)
{     
     float theta;
     char  name[20];


     if (Bootstrapped == 0) {
	  Bootstrapped++;
	  InitialScene();
     } else if (Bootstrapped == 1) {
	  Bootstrapped++;
	  Bootstrap(INITIALhost, INITIALport);
     }

     mapcolor(8, 0, 13, 38); /** The color of the sky... **/
     color(8);
     clear();
     if (Eyeangle_ds != EYEangle) {
	  EyeRotateY(Eyeangle_ds - EYEangle);
	  Eyeangle_ds = EYEangle;
     }

     if (Eyeazimuth_ds != EYEazimuth) {
	  EyeRotateX(Eyeazimuth_ds - EYEazimuth);
	  Eyeazimuth_ds = EYEazimuth;
     }	  

     if (EYEzval != 0.0) {
	  EyeTranslate(0.0, 0.0, EYEzval);
	  EYEzval = 0.0;
     }

     if (EYEyval != 0.0) {
	  EyeTranslate(0.0, EYEyval, 0.0);
	  EYEyval = 0.0;
     }


     callscene(oursceneid);
     swapbuffers();

/*#define VORT_MOVIE*/
#ifdef VORT_MOVIE
     if (SaveMovie) {
	  sprintf(name, "/home/huskerdu/tmp/vp.%d", currentscene);
	  currentscene++;
	  printf("Dumping %s\n", name);
	  X11_dump_pixmap(name, 0,0, 576, 324);
     }
#endif

}


SetDynamicShading()
{
     V_ShadingFreq(d_DYNAMIC);
}

SetStaticShading()
{
     V_ShadingFreq(d_STATIC);
}

Go_InitialView()
{
     EyeInit();
     EyeInitialPoint();
     drawscene();
}



